#include <iostream>

#include "linked_list.h"
#include "algorithms.h"
#include "function_objects.h"

using namespace std;
using namespace SCE;

int main()
{
	// typedefs
	typedef LinkedList<int, true, true> LIST;
	typedef LinkedList<int, true, true>::Iterator LIST_ITERATOR;

	// constants
	int const SIZE = 20;

	LIST list;
	LIST_ITERATOR it1 = list.getIterator();
	int * ip = new int[SIZE];
	int i = SIZE;

	cout << endl << endl;
	cout << "iterator current address\titerator current value";
	cout << endl << endl;
	while (i > 0)
	{
		ip[SIZE - i] = i;
		it1 = i--;
		cout << "\t" << &it1 << "\t\t\t" << *it1 << endl;
	}
	cout << endl << "noof elements == " << list.size() << endl << endl;



	it1 = list.first();
	LIST_ITERATOR it2 = list.last();

	while(it1 != it2)
	{

		it1++;
	}

	cout << " it1 == " << *it1 << "\t\tit2 == " << *it2 << endl;

	it1 = list.first();
	i = -1;
        cout << endl << "greatest value in the array "
		<< greatest_in_range(ip + 0, ip + SIZE - 1, i) << endl;
        cout << "greatest value in the list "
		<< greatest_in_range(it1, it2, i) << endl;



	SumUp<int> adder;
	my_for_each (list.first(), list.last(), adder);
	cout << endl << endl << "sum of the elements in the list: " << adder.getSum() << endl;

	adder.reset();
	my_for_each (ip + 0, ip + SIZE - 1, adder);
	cout << "sum in array: " << adder.getSum() << endl << endl;


	it1 = list.last();

	LessThan<int> less_than_seven(7);
	while(!list.isEmpty())
	{
		if (less_than_seven(*it1))
		{
			cout << *it1 << " is less than seven" << endl;
		}
		it1.remove();
	}
	cout << endl << "noof_elements == " << list.size() << endl;
}
