namespace SCE 
{


/* 
 * This generic function applies the object-function 'f' to all values in the
 * range between (and including) 'first' and 'last'.
 */
template <class BidirectionalIterator, class Function>
Function my_for_each (BidirectionalIterator first, BidirectionalIterator last, Function & f)
{
	f(*first);
	while (first != last)
	{
		first++;
		f(*first);
	}
}

/* 
 * This generic function determines the greatest (operator >) of all  values in
 * the range between (and including) 'first' and 'last'.
 */
template <class BidirectionalIterator, class T>
T const &
greatest_in_range(BidirectionalIterator first, BidirectionalIterator last, T & value)
{
	value = *first;
	while (first != last)
	{
		first++;
		if (*first > value)
		{
			value = *first;
		}
	}
	return value;
}

//
template <class T>
T SCE_Reverse(T range_begin, T range_end)
{/*
	T temp;

        while(range_begin != range_end)
	{
		temp = *range_end;
		range_end = 
	T max;

	if(a > b)
	{
		max = a;
	}
	else
	{
		max = b;
	}

	return max;*/
}


}  // namespace SCE
