#include <iostream>

#include "deque.h"
#include "algorithms.h"

using namespace std;
using namespace SCE;

int main()
{
	typedef Deque<float, true> FloatStack;
	typedef Deque<int, false> IntStack;

	FloatStack fs;
	FloatStack::Iterator it = fs.getIterator();
	float f = 11;

	cout << "Pushing elements onto fs" << endl;
	for (int counter = 0; counter < 10; counter++)
	{
		it = f;
		cout << *it << ' ';
		f -= 1.1;
	}
	cout << endl << "Stack Full." << endl;

	cout << endl << "Popping elements from fs" << endl;
	while (it.hasNext())
	{
		cout << it++ << ' ';
	}
	cout << endl << "Stack Empty" << endl;
}
