#ifndef _IF_H_
#define _IF_H_

namespace SCE {

	
/* 
 * Static metaprogrammed IF statement
 */
template <bool condition, class ThenType, class ElseType>
struct IF
{
    typedef ThenType RET;
};

template <class ThenType, class ElseType>
struct IF <false, ThenType, ElseType>
{
    typedef ElseType RET;
};


}  // namespace SCE

#endif  /* _IF_H_ */

